#include <vcl.h>
#include <dir.h>
#include <math.h>
#include <stdio.h>
#include <alloc.h>

//********************************
//********************************
//********************************
class CBall
{
 public:
 int mass;
 double x,y;
 int d;
 double spdx,spdy;
 Graphics::TBitmap *image;
 Graphics::TBitmap *mask;
 CBall();
 changepos();
 load(char* pathimage,char *pathmask);
};
CBall::CBall()
{
 image=new Graphics::TBitmap;
  mask=new Graphics::TBitmap;
}
CBall::changepos()
{
 x=x+spdx;
 y=y+spdy;
}
CBall::load(char* pathimage,char *pathmask)
{
 image->LoadFromFile(pathimage);
 mask->LoadFromFile(pathmask);
}

//*************************************
class CRope
{
 public:
 int length;
 double upr;
 CRope();
};
CRope::CRope()
{
}
//*************************************
//*************************************
class CSystem
{
 public:
 int bumball,bumwall1,into1,bumwall2,into2;
 CBall *ball1,*ball2;
 CRope *rope;
 CSystem();
 collapse();
 userope();
 changepos();
};
//##################

CSystem::userope()
{
  int l,w,h;
  double power,ang1,ang2,hp,wp;
 w=(ball1->x-ball2->x);
 h=abs(ball1->y-ball2->y);
 l=sqrt(h*h+w*w);
 ang1=sqrt(w*w)/l;
 ang2=sqrt(h*h)/l;
 power=(l-rope->length)*rope->upr;
 hp=ang2*power;
 wp=ang1*power;
 wp=sqrt(wp*wp);
 hp=sqrt(hp*hp);

 if( l>rope->length)
 {
   if(ball1->x>ball2->x)
  {
   ball1->spdx-=wp/ball1->mass;
   ball2->spdx+=wp/ball2->mass;
  }
  else if(ball1->x<ball2->x)
  {
   ball1->spdx+=wp/ball1->mass;
   ball2->spdx-=wp/ball2->mass;
  }
    if(ball1->y>ball2->y)
  {
   ball1->spdy-=hp/ball1->mass;
   ball2->spdy+=hp/ball2->mass;
  }
  else if(ball1->y<ball2->y)
  {
   ball1->spdy+=hp/ball1->mass;
   ball2->spdy-=hp/ball2->mass;
  }
 }
 else  if( l<rope->length)
 {
   if(ball1->x>ball2->x)
  {
   ball1->spdx+=wp/ball1->mass;
   ball2->spdx-=wp/ball2->mass;
  }
  else if(ball1->x<ball2->x)
  {
   ball1->spdx-=wp/ball1->mass;
   ball2->spdx+=wp/ball2->mass;
  }
    if(ball1->y>ball2->y)
  {
   ball1->spdy+=hp/ball1->mass;
   ball2->spdy-=hp/ball2->mass;
  }
  else if(ball1->y<ball2->y)
  {
   ball1->spdy-=hp/ball1->mass;
   ball2->spdy+=hp/ball2->mass;
  }
 }
}
//#################
CSystem::CSystem()
{
 ball1 = new CBall;
 ball2 = new CBall;
 rope = new CRope;
 bumwall1=0;
 bumwall2=0;
 bumball=0;
}
CSystem::changepos()
{
 //   
 ball1->changepos();
 ball2->changepos();
}
//----------------------------------------
CSystem::collapse()
{
//      
 int l,w,h;
 w=(ball1->x-ball2->x);
 h=abs(ball1->y-ball2->y);
 l=sqrt(h*h+w*w);

 if (l<(ball1->d+ball2->d)/2)
 {
  bumball=1;
  double bx,by,px,py,px1,py1,px2,py2;
  double spdx1,spdx2,spdy1,spdy2,tmp,tmp2;
  px1=ball1->spdx *ball1->mass;
  py1=ball1->spdy *ball1->mass;
  px2=ball2->spdx *ball2->mass;
  py2=ball2->spdy *ball2->mass;

  px=(sqrt(px1*px1)+sqrt(px2*px2))/2;
  py=(py1+py2)/2;
 //*********
  int bbx;
  bbx=ball2->x-ball1->x;
  int ccx;
  if(bbx>0)ccx=1;
  else ccx=-1;
 ////////////////
 int bby;
  bby=ball2->y-ball1->y;
  int ccy;
  if(bby>0)ccy=1;
  else ccy=-1;
 //********

  if(ball1->mass<=ball2->mass) spdx1=px/ball1->mass*(-ccx);
  if(ball1->mass>ball2->mass) spdx1=px/ball1->mass*(-ccx);
  if(ball2->mass<=ball1->mass) spdx2=px/ball2->mass*ccx;
  if(ball2->mass>ball1->mass) spdx2=px/ball2->mass*ccx;

  if(ball1->mass<ball2->mass) spdy1=py/ball1->mass*(-ccy);
  if(ball1->mass>ball2->mass) spdy1=py/ball1->mass*(-ccy);
  if(ball2->mass<ball1->mass) spdy2=py/ball2->mass*(ccy);
  if(ball2->mass>ball1->mass) spdy2=py/ball2->mass*ccy;
  //**************************
   if(ball1->y<ball2->y)
  {
   ball1->spdy=ball1->spdy-h/ball1->mass;
   ball2->spdy=ball2->spdy+h/ball2->mass;
  }
  if(ball1->y>ball2->y)
  {
   ball1->spdy=ball1->spdy+h/ball1->mass;
   ball2->spdy=ball2->spdy-h/ball2->mass;
  }

    if(ball1->x<ball2->x)
  {
   ball1->spdx=ball1->spdx+w/ball1->mass;
   ball2->spdx=ball2->spdx-w/ball2->mass;
  }
    if(ball1->x>ball2->x)
  {
   ball1->spdx=ball1->spdx-w/ball1->mass;
   ball2->spdx=ball2->spdx+w/ball2->mass;
  }
 //**************************
  ball2->spdx=spdx2;
  ball1->spdx=spdx1;
  ball1->spdy=spdy1;
  ball2->spdy=spdy2;
  changepos();
 }
 else bumball=0;
 
}
//***********************************************
//***********************************************
//        
//***********************************************
//***********************************************
class CTileset
{
 public:
 char *tilename,*maskname;
 int curtile,lefttile;
 Graphics::TBitmap *tileset;
 Graphics::TBitmap *mask_tileset;
 CTileset();
 Load();
 cut();
};

class CMap
{
 public:
  Graphics::TBitmap *map;
  Graphics::TBitmap *map_back;
  Graphics::TBitmap *map_mask;
  CTileset *tileset;
  //    -  
  //    -  
  // 3   -           
  // 3 -    , 4    
  // "1" -   , "2"- 
  CMap();
  load();
  save();
  char*path;
  int MAP[128][128][5];
  int width,height;
  int ball1x,ball1y,ball2x,ball2y;
  int posx,posy;
  int left,top;
  int curlevel;
  int mx,my;
  char pa[250];
};
//*************************************************
//*** metods of tileset class *********************
CTileset::CTileset()
{
 curtile=0;
 lefttile=0;
 tilename =(char* )malloc(100);
 maskname =(char* )malloc(100);
 tileset = new(Graphics::TBitmap) ;
 mask_tileset= new(Graphics::TBitmap);
}
//**************************
//****   **********
char* cutter (String text)
{
 int last;
 char *strr,*strrr;
 int length,a,b;
 length = text.Length();
 last=text.LastDelimiter('\\');

 strr = (char *) malloc (length+2);
 strrr = (char *) malloc (length-last+2);
 strr=text.c_str();
 b=0;
 for (a=last;a<=length;a++)
 {
  strrr[b]=strr[a];
  b++;
 }
 return (strrr);
}
//****************************
//****************************
CTileset::cut()
{
 tilename=cutter(tilename);
 maskname=cutter(maskname);

}
CTileset::Load()
{
  if (tilename)
  {
   tileset->LoadFromFile(tilename);
  }
   if (maskname)
  {
   mask_tileset->LoadFromFile(maskname);
  }
  cut();
}


//****************************************************
//**************   ************************
CMap::CMap()
{

  CMap::map=new(Graphics::TBitmap);
  CMap::map_back=new(Graphics::TBitmap);
  CMap::map_mask=new(Graphics::TBitmap);
  curlevel=1;
  path=(char*)calloc(sizeof(char),100);
  getcwd(pa, MAXPATH);

  //load();


}
CMap::load()
{
 char rty[4];
 char fgh[15];
 int a,b;
 FILE * fil;
 //sprintf(path,"%s",path);
 fil=fopen(path,"rb");
 fscanf(fil,"%s ",rty);
 width=StrToInt(rty);
 fscanf(fil,"%s ",rty);
 height=StrToInt(rty);
 fscanf(fil,"%s ",rty);
 ball1x=StrToInt(rty);
 fscanf(fil,"%s ",rty);
 ball1y=StrToInt(rty);
 fscanf(fil,"%s ",rty);
 ball2x=StrToInt(rty);
 fscanf(fil,"%s ",rty);
 ball2y=StrToInt(rty);
 for (a=0;a<=width;a++)
 {
  for(b=0;b<=height;b++)
  {
   fscanf(fil,"%s ",rty);
   MAP[a][b][1]=StrToInt(rty);
   fscanf(fil,"%s ",rty);
   MAP[a][b][2]=StrToInt(rty);
   fscanf(fil,"%s ",rty);
   MAP[a][b][3]=StrToInt(rty);
  }
 }
  tileset=new(CTileset);
  fscanf(fil,"%s ",tileset->tilename);
  fscanf(fil,"%s",tileset->maskname);
 char buff[250];
 sprintf(buff,"%s",tileset->tilename);
 sprintf(tileset->tilename,"%s\\tileset\\%s",pa,buff);
 sprintf(buff,"%s",tileset->maskname);
 sprintf(tileset->maskname,"%s\\tileset\\%s",pa,buff);
 //fclose(fil);
  tileset->tileset->LoadFromFile(tileset->tilename);
  tileset->mask_tileset->LoadFromFile(tileset->maskname);

  CMap::map->Width=32*width;
  CMap::map->Height=32*height;
  CMap::map_back->Width=32*width;
  CMap::map_back->Height=32*height;
  CMap::map_mask->Width=32*width;
  CMap::map_mask->Height=32*height;
}

//***********************************************************
//***********************************************************
class CGameEngine
{
  public:

 CSystem *system;
 CMap *map;
 Graphics::TBitmap *move;
 Graphics::TBitmap *move_mask;
 int sposX,sposY,width,height;
 int tip;
 double gravity,uprugost;
 CGameEngine();
 setmap(char* path);
 drawmap();
 drawmap_control();
 collapsewithmapfor2ball();
 collapsewithmapfor1ball();
 gravitate();
 movemouse(int x,int y,int button);
};
//\\\\\\\\\\\\\\methods/////////////////////\\
 CGameEngine::movemouse(int x,int y,int button)
 {
 int b;
  int l,w,h,ll;
  double power,ang1,ang2,hp,wp;
  w=(system->ball1->x-system->ball2->x);
  h=abs(system->ball1->y-system->ball2->y);
  l=sqrt(h*h+w*w);
  ang1=sqrt(w*w)/l;
  ang2=sqrt(h*h)/l;
   
  if (button==1)
  {
   if(x>system->ball1->x-16&&x<system->ball1->x+16&&y>system->ball1->y-16&&y<system->ball1->y+16)
   {
    if(l<system->ball1->d+2)
     {
      if(system->ball1->x<system->ball2->x) system->ball1->x=system->ball1->x-ang1*2;
      else if(system->ball1->x>system->ball2->x) system->ball1->x=system->ball1->x+ang1*2;
      if(system->ball1->y<system->ball2->y) system->ball1->y=system->ball1->y-ang2*2;
      else if(system->ball1->y>system->ball2->y) system->ball1->y=system->ball1->y+ang2*2;
     }
   else  if(map->MAP[x/32][y/32][3]==2)
    {
     if((map->MAP[(x-16)/32][y/32][3]==2)&&(map->MAP[(x+16)/32][y/32][3]==2)) system->ball1->x=x;
     if((map->MAP[(x)/32][(y-15)/32][3]==2)&&system->ball1->y>y&&(map->MAP[(x)/32][(y-10)/32][3]==2)) system->ball1->y=y;
     if((map->MAP[(x)/32][(y-15)/32][3]==2)&&system->ball1->y<y&&(map->MAP[(x)/32][(y+10)/32][3]==2)) system->ball1->y=y;

    }
   }

   if(x>system->ball2->x-16&&x<system->ball2->x+16&&y>system->ball2->y-16&&y<system->ball2->y+16)
   {
     if(l<system->ball1->d+2)
     {
      if(system->ball2->x<system->ball1->x) system->ball2->x=system->ball2->x-ang1*2;
      else if(system->ball2->x>system->ball1->x) system->ball2->x=system->ball2->x+ang1*2;
      if(system->ball2->y<system->ball1->y) system->ball2->y=system->ball2->y-ang2*2;
      else if(system->ball2->y>system->ball1->y) system->ball2->y=system->ball2->y+ang2*2;
     }
    else if(map->MAP[x/32][y/32][3]==2)
    {
     if((map->MAP[(x-16)/32][y/32][3]==2)&&(map->MAP[(x+16)/32][y/32][3]==2)) system->ball2->x=x;
     if((map->MAP[(x)/32][(y-15)/32][3]==2)&&system->ball2->y>y&&(map->MAP[(x)/32][(y-10)/32][3]==2)) system->ball2->y=y;
     if((map->MAP[(x)/32][(y-15)/32][3]==2)&&system->ball2->y<y&&(map->MAP[(x)/32][(y+10)/32][3]==2)) system->ball2->y=y;



    }
   }
  }
 }
 CGameEngine::gravitate()
 {
  int cellx,celly,type,top;
  double a;
  cellx=system->ball1->x/32;
  celly=system->ball1->y/32;
  top=celly*32;
  type=map->MAP[cellx][celly+1][1];
  a=sqrt(system->ball1->spdy*system->ball1->spdy);
  if ((type<=1||(type>=9&&type<=12)||type>15)&&system->ball1->y>=top-16)
  {
    system->ball1->spdy=system->ball1->spdy+gravity;
  }

  cellx=system->ball2->x/32;
  celly=system->ball2->y/32;
  top=celly*32;
  type=map->MAP[cellx][celly+1][1];
  a=sqrt(system->ball2->spdy*system->ball2->spdy);
  if ((type<=5||(type>=9&&type<=12)||type>15)&&system->ball2->y>=top-16)
  {
    system->ball2->spdy=system->ball2->spdy+gravity;
  }
 }
 //**********
 CGameEngine::CGameEngine()
 {
  system = new CSystem;
  move = new Graphics::TBitmap;
  move_mask = new Graphics::TBitmap;
  map=new CMap;
 }
//*********************************
 CGameEngine::setmap(char* path)
 {
  map->path=path;
  map->load();
  move->LoadFromFile("tileset\\move.bmp");
  move_mask->LoadFromFile("tileset\\move_mask.bmp");
 }
//************************
//########################
 CGameEngine::drawmap()
 {
  int a,b;
  map->map->Canvas->Brush->Color=clBlack;
  map->map->Canvas->Rectangle(0,0,map->map->Width,map->map->Height);

  map->map_mask->Canvas->Brush->Color=clWhite;
  map->map_mask->Canvas->Rectangle(0,0,map->map->Width,map->map->Height);
  for (a=0;a<=map->width;a++)
  {
   for (b=0;b<=map->height;b++)
   {
    map->map_back->Canvas->CopyMode=cmSrcCopy;
    map->map_back->Canvas->CopyRect(Rect(a*32,b*32,a*32+32,b*32+32),map->tileset->tileset->Canvas,Rect((map->MAP[a][b][2]-1)*32,0,(map->MAP[a][b][2]-1)*32+32,32));
    map->map_mask->Canvas->CopyMode=cmSrcCopy;
    map->map_mask->Canvas->CopyRect(Rect(a*32,b*32,a*32+32,b*32+32),map->tileset->mask_tileset->Canvas,Rect((map->MAP[a][b][1]-1)*32,0,(map->MAP[a][b][1]-1)*32+32,32));
    map->map->Canvas->CopyMode=cmSrcAnd;
    map->map->Canvas->CopyRect(Rect(a*32,b*32,a*32+32,b*32+32),map->tileset->mask_tileset->Canvas,Rect((map->MAP[a][b][1]-1)*32,0,(map->MAP[a][b][1]-1)*32+32,32));
    map->map->Canvas->CopyMode=cmSrcPaint;
    map->map->Canvas->CopyRect(Rect(a*32,b*32,a*32+32,b*32+32),map->tileset->tileset->Canvas,Rect((map->MAP[a][b][1]-1)*32,0,(map->MAP[a][b][1]-1)*32+32,32));
   }
  }
 }
 //*****************************
  CGameEngine::drawmap_control()
 {
  int a,b;
  map->map->Canvas->Brush->Color=clBlack;
  map->map->Canvas->Rectangle(0,0,map->map->Width,map->map->Height);
  for (a=0;a<=map->width;a++)
  {
   for (b=0;b<=map->height;b++)
   {
    map->map_back->Canvas->CopyMode=cmSrcCopy;
    map->map_back->Canvas->CopyRect(Rect(a*32,b*32,a*32+32,b*32+32),map->tileset->tileset->Canvas,Rect((map->MAP[a][b][2]-1)*32,0,(map->MAP[a][b][2]-1)*32+32,32));
    map->map_mask->Canvas->CopyMode=cmSrcCopy;
    map->map_mask->Canvas->CopyRect(Rect(a*32,b*32,a*32+32,b*32+32),map->tileset->mask_tileset->Canvas,Rect((map->MAP[a][b][1]-1)*32,0,(map->MAP[a][b][1]-1)*32+32,32));
    map->map->Canvas->CopyMode=cmSrcAnd;
    map->map->Canvas->CopyRect(Rect(a*32,b*32,a*32+32,b*32+32),map->tileset->mask_tileset->Canvas,Rect((map->MAP[a][b][1]-1)*32,0,(map->MAP[a][b][1]-1)*32+32,32));
    map->map->Canvas->CopyMode=cmSrcPaint;
    map->map->Canvas->CopyRect(Rect(a*32,b*32,a*32+32,b*32+32),map->tileset->tileset->Canvas,Rect((map->MAP[a][b][1]-1)*32,0,(map->MAP[a][b][1]-1)*32+32,32));
    if(map->MAP[a][b][3]==2)
    {
     map->map->Canvas->CopyMode=cmSrcAnd;
     map->map_mask->Canvas->CopyMode=cmSrcAnd;
     map->map_mask->Canvas->CopyRect(Rect(a*32,b*32,a*32+32,b*32+32),move_mask->Canvas,Rect(0,0,32,32));
     map->map->Canvas->CopyRect(Rect(a*32,b*32,a*32+32,b*32+32),move_mask->Canvas,Rect(0,0,32,32));
     map->map->Canvas->CopyMode=cmSrcPaint;
     map->map->Canvas->CopyRect(Rect(a*32,b*32,a*32+32,b*32+32),move->Canvas,Rect(0,0,32,32));

    }
   }
  }
 }
 //############################



CGameEngine::collapsewithmapfor1ball()
{
 //**************************ball1***********************
 double onx,ony,nx,ny,l,type,ang1,ang2;
 int cx,cy;

 //*************************************
 //***** for 1 ball
 //*************************************
 nx=system->ball1->x+system->ball1->spdx;
 ny=system->ball1->y+system->ball1->spdy;
 onx=system->ball1->x+system->ball1->spdx;
 ony=system->ball1->y+system->ball1->spdy;
 l=sqrt(nx*nx+ny*ny);
 ang1=nx/l;
 ang2=ny/l;
 l=l+system->ball1->d/2;
 nx=ang1*l;
 ny=ang2*l;
 cx=nx/32;
 cy=ny/32;
 type=map->MAP[(int)cx][(int)cy][1];
 tip=type;
//************
 if (type==3)
 {
  int locx,locy,tmp;
   locx=nx-abs(nx/32)*32;
   locy=ny-abs(ny/32)*32;
   tmp=abs(onx/32);
   if(tmp<=cx)
   {
    if((locx-locy)>0||system->ball1->spdx>32|system->ball1->spdx<-32||system->ball1->spdy<-32||system->ball1->spdy>32)
    { double a;
     if(system->ball1->spdy<=0)
     {
      a=system->ball1->spdy;
      system->ball1->spdy=system->ball1->spdx*uprugost;
      system->ball1->spdx=a*uprugost;
     }
     else if(system->ball1->spdy>=0)
     {
      a=system->ball1->spdy;
      system->ball1->spdy=system->ball1->spdx*uprugost;
      system->ball1->spdx=a*uprugost;
     }
    }
   }
   else if(onx/32>cx)
    {
     system->ball1->spdx=-system->ball1->spdx*uprugost;
    }
   else if(ony/32>cy)
    {
     system->ball1->spdy=-system->ball1->spdy*uprugost;
    }

 }
 //****************
  else if (type==4)
 {
  int locx,locy;
   locx=nx-abs(nx/32)*32;
   locy=ny-abs(ny/32)*32;
   if(abs(onx/32)+1>=cx)
   {
    if((locx+locy)<32||system->ball1->spdx>32|system->ball1->spdx<-32||system->ball1->spdy<-32||system->ball1->spdy>32)
    { double a;
     a=system->ball1->spdy;
     system->ball1->spdy=-system->ball1->spdx*uprugost;
     system->ball1->spdx=-a*uprugost;
    }
   }
   else if(onx/32<cx)
    {
     system->ball1->spdx=-system->ball1->spdx*uprugost;
    }
   else if(ony/32>cy)
    {
     system->ball1->spdy=-system->ball1->spdy*uprugost;
    }
 }
 //*********
   else if (type==13)
 {

     double a;
     a=system->ball1->spdy;
     system->ball1->spdy=-system->ball1->spdx*uprugost;
     system->ball1->spdx=-a*uprugost;

 }
 //****************
  else if (type==2)
 {
  int locx,locy;
   locx=nx-abs(nx/32)*32;
   locy=ny-abs(ny/32)*32;
   if(abs(onx/32)<=cx)
   {
    if((locx+locy)>=32||system->ball1->spdx>32|system->ball1->spdx<-32||system->ball1->spdy<-32||system->ball1->spdy>32)
    { double a;
     a=system->ball1->spdy;
     system->ball1->spdy=-system->ball1->spdx*uprugost;
     system->ball1->spdx=-a*uprugost;
    }
   }
   else if(onx/32<cx)
    {
     system->ball1->spdx=-system->ball1->spdx*uprugost;
    }
   else if(ony/32>cy)
    {
     system->ball1->spdy=-system->ball1->spdy*uprugost;
    }
 }
 //****************
 else if (type==14)
 {
  double a;
     a=system->ball1->spdy;
     system->ball1->spdy=-system->ball1->spdx*uprugost;
     system->ball1->spdx=-a*uprugost;
 }
 //*****************
   else if (type==1)
  {
   int locx,locy,tmp;
   locx=nx-abs(nx/32)*32;
   locy=ny-abs(ny/32)*32;
   tmp=abs(onx/32);
   if(tmp<=cx)
   {
    if((locx-locy)<0||system->ball1->spdx>32|system->ball1->spdx<-32||system->ball1->spdy<-32||system->ball1->spdy>32)
    { double a;
     if(system->ball1->spdy<=0)
     {
      a=system->ball1->spdy;
      system->ball1->spdy=system->ball1->spdx*uprugost;
      system->ball1->spdx=a;
     }
     else if(system->ball1->spdy>=0)
     {
      a=system->ball1->spdy;
      system->ball1->spdy=system->ball1->spdx*uprugost;
      system->ball1->spdx=a;
     }
    }
   }
   else if(onx/32<cx)
    {
     system->ball1->spdx=-system->ball1->spdx*uprugost;
    }
   else if(ony/32>cy)
    {
     system->ball1->spdy=-system->ball1->spdy*uprugost;
    }
   }
  //****************
   else if (type==15)
  {
   double a;
      a=system->ball1->spdy;
      system->ball1->spdy=system->ball1->spdx*uprugost;
      system->ball1->spdx=a*uprugost;
   }
 //*****************
  else if (type==12)
   {
   int locx,locy,tmp;
   tmp=abs(onx/32);
   if(tmp<=cx)
   {
     double a;
     if(system->ball1->spdy<=0)
     {
      a=system->ball1->spdy;
      system->ball1->spdy=system->ball1->spdx*uprugost;
      system->ball1->spdx=a*uprugost;
     }
     else if(system->ball1->spdy>=0)
     {
      a=system->ball1->spdy;
      system->ball1->spdy=system->ball1->spdx*uprugost;
      system->ball1->spdx=a*uprugost;
     }
   }
   else if(onx/32>cx)
    {
     system->ball1->spdx=-system->ball1->spdx*uprugost;
    }
   else if(ony/32>cy)
    {
     system->ball1->spdy=-system->ball1->spdy*uprugost;
    }
 }
 //*************************
  else if (type==8||type==6)
 {
  system->ball1->spdy=-system->ball1->spdy*uprugost;
 }
 //*************************
  else if (type==5||type==7)
 {
  system->ball1->spdx=-system->ball1->spdx*uprugost;
 }
  else if(type==9)
  {
   int aaa,bbb;

   if((onx/32<cx||onx/32>cx)&&(ony/32>cy&&ony/32<cy+32))system->ball1->spdx=-system->ball1->spdx*uprugost;
   if((ony/32<cy||ony/32>cy)&&(onx/32>cx&&onx/32<cx+32))system->ball1->spdy=-system->ball1->spdy*uprugost;
  }
  if(type>0)
  {
   if(system->into1==0)
   {
    system->bumwall1=1;
    system->into1=1;
   }
  }
  else
  {
   system->into1=0;
   system->bumwall1=0;
  }
 };
CGameEngine::collapsewithmapfor2ball()
{
 //**************************ball1***********************
 long double onx,ony,nx,ny,l,type,ang1,ang2;
 int cx,cy;
//***************************************
//******* for 2 ball ********************
 nx=system->ball2->x+system->ball2->spdx;
 ny=system->ball2->y+system->ball2->spdy;
 onx=system->ball2->x+system->ball2->spdx;
 ony=system->ball2->y+system->ball2->spdy;
 l=sqrt(nx*nx+ny*ny);
 ang1=nx/l;
 ang2=ny/l;
 l=l+system->ball2->d/2;
 nx=ang1*l;
 ny=ang2*l;
 cx=nx/32;
 cy=ny/32;
 type=map->MAP[(int)cx][(int)cy][1];
 tip=type;
//************
 if (type==3)
 {
  int locx,locy,tmp;
   locx=nx-abs(nx/32)*32;
   locy=ny-abs(ny/32)*32;
   tmp=abs(onx/32);
   if(tmp<=cx)
   {
    if((locx-locy)>0||system->ball2->spdx>32|system->ball2->spdx<-32||system->ball2->spdy<-32||system->ball2->spdy>32)
    { double a;
     if(system->ball2->spdy<=0)
     {
      a=system->ball2->spdy;
      system->ball2->spdy=system->ball2->spdx*uprugost;
      system->ball2->spdx=a*uprugost;
     }
     else if(system->ball2->spdy>=0)
     {
      a=system->ball2->spdy;
      system->ball2->spdy=system->ball2->spdx*uprugost;
      system->ball2->spdx=a*uprugost;
     }
    }
   }
   else if(onx/32>cx)
    {
     system->ball2->spdx=-system->ball2->spdx*uprugost;
    }
   else if(ony/32>cy)
    {
     system->ball2->spdy=-system->ball2->spdy*uprugost;
    }
 }
 //****************
  else if (type==4)
 {
  int locx,locy;
   locx=nx-abs(nx/32)*32;
   locy=ny-abs(ny/32)*32;
   if(abs(onx/32)+1>=cx)
   {
    if((locx+locy)<32||system->ball2->spdx>32|system->ball2->spdx<-32||system->ball2->spdy<-32||system->ball2->spdy>32)
    { double a;
     a=system->ball2->spdy;
     system->ball2->spdy=-system->ball2->spdx*uprugost;
     system->ball2->spdx=-a*uprugost;
    }
   }
   else if(onx/32<cx)
    {
     system->ball2->spdx=-system->ball2->spdx*uprugost;
    }
   else if(ony/32>cy)
    {
     system->ball2->spdy=-system->ball2->spdy*uprugost;
    }
 }
 //*********
   else if (type==13)
 {

     double a;
     a=system->ball2->spdy;
     system->ball2->spdy=-system->ball2->spdx*uprugost;
     system->ball2->spdx=-a*uprugost;

 }
 //****************
  else if (type==2)
 {
  int locx,locy;
   locx=nx-abs(nx/32)*32;
   locy=ny-abs(ny/32)*32;
   if(abs(onx/32)<=cx)
   {
    if((locx+locy)>=32||system->ball2->spdx>32|system->ball2->spdx<-32||system->ball2->spdy<-32||system->ball2->spdy>32)
    { double a;
     a=system->ball2->spdy;
     system->ball2->spdy=-system->ball2->spdx*uprugost;
     system->ball2->spdx=-a*uprugost;
    }
   }
   else if(onx/32<cx)
    {
     system->ball2->spdx=-system->ball2->spdx*uprugost;
    }
   else if(ony/32>cy)
    {
     system->ball2->spdy=-system->ball2->spdy*uprugost;
    }
 }
 //****************
 else if (type==14)
 {
  double a;
     a=system->ball2->spdy;
     system->ball2->spdy=-system->ball2->spdx*uprugost;
     system->ball2->spdx=-a*uprugost;
 }
 //*****************
   else if (type==1)
  {
   int locx,locy,tmp;
   locx=nx-abs(nx/32)*32;
   locy=ny-abs(ny/32)*32;
   tmp=abs(onx/32);
   if(tmp<=cx)
   {
    if((locx-locy)<0)
    { double a;
     if(system->ball2->spdy<=0||system->ball2->spdx>32|system->ball2->spdx<-32||system->ball2->spdy<-32||system->ball2->spdy>32)
     {
      a=system->ball2->spdy;
      system->ball2->spdy=system->ball2->spdx*uprugost;
      system->ball2->spdx=a*uprugost;
     }
     else if(system->ball2->spdy>=0)
     {
      a=system->ball2->spdy;
      system->ball2->spdy=system->ball2->spdx*uprugost;
      system->ball2->spdx=a*uprugost;
     }
    }
   }
   else if(onx/32<cx)
    {
     system->ball2->spdx=-system->ball2->spdx*uprugost;
    }
   else if(ony/32>cy)
    {
     system->ball2->spdy=-system->ball2->spdy*uprugost;
    }
   }
  //****************
   else if (type==15)
  {
   double a;
      a=system->ball2->spdy;
      system->ball2->spdy=system->ball2->spdx*uprugost;
      system->ball2->spdx=a*uprugost;
   }
 //*****************
  else if (type==12)
   {
   int locx,locy,tmp;
   tmp=abs(onx/32);
   if(tmp<=cx)
   {
     double a;
     if(system->ball2->spdy<=0||system->ball2->spdx>32|system->ball2->spdx<-32||system->ball2->spdy<-32||system->ball2->spdy>32)
     {
      a=system->ball2->spdy;
      system->ball2->spdy=system->ball2->spdx*uprugost;
      system->ball2->spdx=a*uprugost;
     }
     else if(system->ball2->spdy>=0)
     {
      a=system->ball2->spdy;
      system->ball2->spdy=system->ball2->spdx*uprugost;
      system->ball2->spdx=a*uprugost;
     }
   }
   else if(onx/32>cx)
    {
     system->ball2->spdx=-system->ball2->spdx*uprugost;
    }
   else if(ony/32>cy)
    {
     system->ball2->spdy=-system->ball2->spdy*uprugost;
    }
 }
 //*************************
  else if (type==8||type==6)
 {
  system->ball2->spdy=-system->ball2->spdy*uprugost;
 }
 //*************************
  else if (type==5||type==7)
 {
  system->ball2->spdx=-system->ball2->spdx*uprugost;
 }
  else if(type==9)
  {

   if((onx/32<cx||onx/32>cx)&&(ony/32>cy&&ony/32<cy+32))system->ball2->spdx=-system->ball2->spdx*uprugost;
   if((ony/32<cy||ony/32>cy)&&(onx/32>cx&&onx/32<cx+32))system->ball2->spdy=-system->ball2->spdy*uprugost;
  }
  if(tip>0)
  {
   if(system->into2==0)
   {
    system->bumwall2=1;
    system->into2=1;
   }
  }
  else
  {
   system->bumwall2=0;
   system->into2=0;
  }
}
//////////////////////////////////////////////////

  
